﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.SignalR;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Performance.Services
{
    public class AllotLogHub : Hub
    {
        public override Task OnConnectedAsync()
        {
            return base.OnConnectedAsync();
        }
        public override Task OnDisconnectedAsync(Exception exception)
        {
            //1 查询用户分组信息
            var groupName = "aaaa";

            //2 删除数据库中用户分组数据
            if (RedisHelper.HExists("MyGroup", groupName))
            {
                var connectionId = Context.ConnectionId;
                RedisHelper.HDel("MyGroup", groupName);
            }

            //3 分组中删除用户
            Groups.RemoveFromGroupAsync(Context.ConnectionId, groupName);
            return base.OnDisconnectedAsync(exception);
        }

        public async Task AddGroup(string token, string groupName)
        {
            if (!RedisHelper.HExists("MyGroup", groupName))
            {
                //1 向数据库中插入用户及分组信息
                var connectionId = Context.ConnectionId;
                RedisHelper.HSet("MyGroup", groupName, connectionId);


                //2 将用户插入分组
                await Groups.AddToGroupAsync(Context.ConnectionId, groupName);
            }
        }
    }
}
